<?php
/**
 * @file
 * Contains Login Settings for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
include "mo_saml_visualTour.php";
 function miniorange_saml_login_options($form, &$form_state)
 {
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));


  $form['markup_1'] = array(
    '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container"  id="mosaml_redirect_chckbx">
                   <b><span style="font-size: 17px;">SIGN IN SETTINGS</span></b>
                    <a class="btn btn-primary btn-large restart_button" id="restart_tour_button">Take a Tour</a>
                    <br><br><hr><br/>
                    <div class="mo_saml_highlight_background_note"> <strong>Note:</strong> Available in 
                    <a href="' . Utilities::getLicensePageURL() . '">Standard, Premium and Enterprise</a> versions of the module</div><br>',
  );

  $form['miniorange_saml_force_auth'] = array(
    '#type' => 'checkbox',
    '#title' => t('Protect website against anonymous access.'),
	'#disabled' => TRUE,
    '#attributes' => array('id'=>'mosaml_chkbx_prot'),
    '#description' => t('<b>Note: </b>Users will be redirected to your IdP for login in case user is not logged in and tries to access website.<br><br>'),
  );


  $form['miniorange_saml_auto_redirect'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>auto redirect the user to IdP.</b>'),
	'#disabled' => TRUE,
      '#attributes' => array('id'=>'mosaml_vt_auto_redirect'),
      '#description' => t('<b>Note: </b>Users will be redirected to your IdP for login when the login page is accessed.<br><br>'),
  );

  $form['miniorange_saml_enable_backdoor'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to enable <b>backdoor login.</b>'),
	'#disabled' => TRUE,
    '#attributes' => array('id'=>'mosaml-chkbx-enable-backdoor'),
    '#description' => t('<b>Note: </b>Checking this option <b>creates a backdoor login to your Website using Drupal credentials</b>
           incase you<br> get locked out of your IdP.<br> <strong>Note down this URL:</strong> <code>We provide bcakdoor URL in Standard, Premium and Enterprise versions of the module.</code><br><br>'),
  );

     $form['miniorange_saml_default_relaystate'] = array(
         '#type' => 'textfield',
         '#title' => t('Default Redirect URL after login.'),
         '#attributes' => array('style' => 'width:81%;background-color: hsla(0,0%,0%,0.08) !important;','id'=>'mosaml_def_redirect','placeholder' => 'Enter Default Redirect URL'),
         '#disabled' => TRUE,
         '#suffix'=> '</br>',
     );

     $form['miniorange_saml_gateway_config_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save Configuration'),
         '#disabled' => TRUE,
       '#attributes' => array('style' => 'display: block;margin-left: auto;margin-right: auto;'),
         '#suffix' => '<br><br><br></div>',

     );

     Utilities::spConfigGuide($form, $form_state);

     Utilities::AddSupportButton($form, $form_state);

  return $form;

 }
