<?php
/**
 * @file
 * Contains Attribute and Role Mapping for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
include "mo_saml_visualTour.php";
 function miniorange_saml_mapping($form, &$form_state)
 {
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

     $form['markup_top'] = array(
         '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container"><b>
                        <span style="font-size: 17px;">ATTRIBUTE MAPPING</span></b>
                        <a class="btn btn-primary btn-large restart_button" id="restart_tour_button">Take a Tour</a>
                        <br><br><hr><br/>'
     );

     $form['miniorange_saml_account_username_by'] = array(
        '#type' => 'select',
        '#title' => t('Login/Create Drupal account by'),
        '#options' => array(
            1 => t('Username'),
            2 => t('Email')
        ),
        '#default_value' => variable_get('miniorange_saml_login_by'),
        '#attributes' => array('style' => 'width:81%','id'=>'mosaml_vt_username'),
     );

     $form['Configure_Attribute_Mapping_End'] = array(
         '#markup' => '<br><div class="mo_saml_highlight_background_note_1"><b>Note: Username Attribute</b>, <b>Email Attribute</b> and <b>Role Key</b> are configurable in 
                        <a href="' . Utilities::getLicensePageURL() . '">Standard, Premium and Enterprise</a> versions of the module.<br>
                       </div><br>',
     );

     $form['miniorange_saml_username_attribute'] = array(
        '#type' => 'textfield',
        '#title' => t('Username Attribute'),
        '#attributes' => array('style' => 'width:81%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'NameID'),
	      '#disabled' => TRUE,
        '#prefix' => '<div id="miniorange_saml_vt_mapping">',
     );

     $form['miniorange_saml_email_attribute'] = array(
        '#type' => 'textfield',
        '#title' => t('Email Attribute'),
        '#attributes' => array('style' => 'width:81%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'NameID'),
	      '#disabled' => TRUE,
        '#suffix' => '</div>',
     );

     $form['miniorange_saml_gateway_config_atrr_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save Configuration'),
         '#submit' => array('miniorange_saml_save_mapping_settings'),
         '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
           box-shadow: 0 2px 0 #006799;border-color: #337ab7 #337ab7 #337ab7;display: block;margin-left: auto;margin-right: auto;'),
         '#suffix' => '<br></div>',
     );

     Utilities::spConfigGuide($form, $form_state);

     $form['markup_cam_attr'] = array(
         '#markup' => '</div><div class="mo_saml_table_layout mo_saml_container" style="margin-top: -125px;"><h4>CUSTOM ATTRIBUTE MAPPING </h4><hr><br>
                    <div class="mo_saml_highlight_background_note"><b>Note: </b>Custom Attribute Mapping are configurable in
                    <a href="' . Utilities::getLicensePageURL() . '">Premium and Enterprise</a> versions of the module.</div>',
     );

     $form['markup_cam'] = array(
         '#markup' => '<br><div class="mo_saml_highlight_background_note_1"><p><b>NOTE: </b> Add the Drupal field attributes in the Attribute Name textfield and add the 
                            IdP attibutes that you need to map with the drupal attributes in the IdP Attribute Name textfield. 
                             <br> <b>Attribute Name:</b> It is the user attribute (machine name) whose value you want to set in site.
                             <br> <b>IdP Attribute Name:</b> It is the name which you want to get from your IDP. It should be unique.</p></div>
                             <p><b>For example: If the attribute name in the drupal is name then its machine name will be field_name.</b></p>',
     );

     $form['miniorange_saml_attr5_name'] = array(
	      '#type' => 'textfield',
	      '#title' => t('Attribute Name 1 '),
        '#attributes' => array('style' => 'width:81%; background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Attribute Name'),
	      '#disabled' => TRUE,
        '#prefix' => '<div id="miniorange_saml_vt_customAttr">',
     );

     $form['miniorange_saml_idp_attr5_name'] = array(
    	  '#type' => 'textfield',
    	  '#title' => t('IdP Attribute Name 1 '),
    	  '#attributes' => array('style' => 'width:81%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter IdP Attribute Name'),
    	  '#disabled' => TRUE,
     );

     $form['markup_idp_user_attr_header'] = array(
         '#markup' => '</div><br /><h4> ADDITIONAL USER ATTRIBUTES (OPTIONAL)<a href="' . Utilities::getLicensePageURL() . '"> <b>[Premium and Enterprise]</b>
                        </a> <input type="button" class="btn btn-primary" style="width:3%;margin-left:2%;margin-right:2%;" value="+" onclick="add_user_attibute();" /> 
                        <input type="button" class="btn btn-danger" style="width:3%;" value="-" onclick="remove_user_attibute();" /></h4>',
     );

     $form['markup_idp_user_attr_note'] = array(
         '#markup' => '<div class="messages status" style="width: 74%;">Attribute Name: It is the user attribute (machine name) whose value you want to set in site.
                        <br />IdP Attribute Name: It is the name which you want to get from your IDP. It should be unique.</div><br>',
     );

     $form['miniorange_saml_gateway_config_custom_attr_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save Configuration'),
         '#disabled' => TRUE,
         '#submit' => array('miniorange_saml_save_mapping_settings'),
         '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
           box-shadow: 0 2px 0 #006799;border-color: #337ab7 #337ab7 #337ab7;display: block;margin-left: auto;margin-right: auto;'),
         '#suffix' => '</br></div>',
     );

     $form['mosaml_vt_checkbx']=array(
         '#markup'=>'<div class="mo_saml_table_layout mo_saml_container"><h4>ROLE MAPPING </h4>
                    <hr><br><div id="mosaml_vt_enable_chckbx">'
     );

     $form['miniorange_saml_enable_rolemapping'] = array(
         '#type' => 'checkbox',
         '#title' => t('Check this option if you want to <b>enable Role Mapping</b>'),
         '#default_value' => variable_get('miniorange_saml_enable_rolemapping'),
         '#suffix' => '</div><div id="mosaml_vt_defaut_group">',
     );

     $mrole= user_roles($membersonly = TRUE);
     $drole = array_search(variable_get('miniorange_saml_default_role',''),$mrole);

     $form['miniorange_saml_default_mapping'] = array(
         '#type' => 'select',
         '#title' => t('Select default group for the new users'),
         '#options' => $mrole,
         '#default_value' => $drole,
         '#attributes' => array('style' => 'width:81%'),
         '#suffix' => '</div><div class="mo_saml_highlight_background_note_1">',
     );

     $form['miniorange_disable_attribute'] = array(
         '#type' => 'checkbox',
         '#title' => t('Do not update existing user&#39;s role.'),
         '#disabled' => TRUE,
     );

     $form['miniorange_saml_disable_role_update'] = array(
         '#type' => 'checkbox',
         '#title' => t('Check this option if you do not want to update user role if roles not mapped.'),
         '#disabled' => TRUE,
     );

     $form['miniorange_saml_disable_autocreate_users'] = array(
         '#type' => 'checkbox',
         '#title' => t('Check this option if you want to disable <b>auto creation</b> of users if user does not exist.'),
         '#disabled' => TRUE,
     );

     $form['miniorange_premium_features'] = array(
       '#markup'=> '<div><b>Note:</b> These features are availabe in <a href="\' . Utilities::getLicensePageURL() . \'">Premium and Enterprise</a> versions of the module.</div>',
     );

     $form['markup_cam_attr_map1'] = array(
         '#markup' => '</div><br><br><h4>CUSTOM ROLE MAPPING </h4><hr><br>
                        <div class="mo_saml_highlight_background_note"><b>NOTE : </b>Custom Role Mapping are configurable in 
                        <a href="' . Utilities::getLicensePageURL() . '">Premium and Enterprise</a> versions of the module.</div><br>',
     );

     $form['miniorange_saml_idp_attr1_name'] = array(
         '#type' => 'textfield',
         '#title' => t('Role Key'),
         '#attributes' => array('style' => 'width:81%; background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Role Attribute'),
         '#description' => '<b>Note:</b> You can find role key in test configuration window.',
         '#disabled' => TRUE,
     );

     foreach($mrole as $roles) {
        $rolelabel = str_replace(' ','',$roles);
        $form['miniorange_saml_role_' . $rolelabel] = array(
	        '#type' => 'textfield',
	        '#title' => t($roles),
	        '#attributes' => array('style' => 'width:81%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Semi-colon(;) separated Group/Role value for ' . $roles),
	        '#disabled' => TRUE,
        );
     }

     $form['markup_cam_log_1'] = array(
        '#markup' => '<div id="miniorange_saml_vt_customLogin"></br><h4>CUSTOM LOGIN/LOGOUT (OPTIONAL): </h4><hr>
                <br><div class="mo_saml_highlight_background_note_1"><b>Note: </b>Custom Login/Logout are configurable in 
                <a href="' . Utilities::getLicensePageURL() . '">Premium and Enterprise</a> versions of the module.</div><br>',
     );

	  foreach($mrole as $drupalKey=>$drupalRoles) {
		    $lbl = str_replace(' ','',$drupalRoles . '_sin');
		    $l= str_replace(' ','',$drupalRoles . '_sout');
		    $form[$lbl] = array(
			    '#type' => 'textfield',
			    '#title' => $drupalRoles,
			    '#attributes' => array('style' => 'width:81%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Login URL'),
			    '#disabled' => TRUE,
        );
		    $form[$l] = array(
			    '#type' => 'textfield',
			    '#attributes' => array('style' => 'width:81%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Logout URL'),
			    '#disabled' => TRUE,
        );
	  }

    $form['miniorange_saml_gateway_config_custom_role_submit'] = array(
        '#type' => 'submit',
        '#value' => t('Save Configuration'),
        '#submit' => array('miniorange_saml_save_mapping_settings'),
        '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
            box-shadow: 0 2px 0 #006799;border-color: #337ab7 #337ab7 #337ab7;display: block;margin-left: auto;margin-right: auto;'),
        '#prefix' => '</div>',
        '#suffix' => '<br></div>',

    );

    Utilities::AddSupportButton($form, $form_state);

    return $form;

 }

  function miniorange_saml_save_mapping_settings($form, &$form_state) {
      $mrole= user_roles($membersonly = TRUE);
      $enable_rolemapping = $form['miniorange_saml_enable_rolemapping']['#value'];
      $login_by = $form['miniorange_saml_account_username_by']['#value'];
      $username_attribute = $form['miniorange_saml_username_attribute']['#value'];
      $email_attribute = $form['miniorange_saml_email_attribute']['#value'];
      $default_mapping= $form['miniorange_saml_default_mapping']['#value'];

      $enable_rolemapping_value = $enable_rolemapping == 1 ? TRUE : FALSE;
      $mo_default_role = $enable_rolemapping_value === TRUE ? $mrole[$default_mapping] : $mrole[2];

      variable_set('miniorange_saml_enable_rolemapping', $enable_rolemapping_value);
      variable_set('miniorange_saml_default_role', $mo_default_role);
      variable_set('miniorange_saml_login_by', $login_by);
      variable_set('miniorange_saml_username_attribute', $username_attribute);
      variable_set('miniorange_saml_email_attribute', $email_attribute);
      drupal_set_message(t('Mapping Configuration Settings successfully saved'));
  }
