<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

/**
 * Showing Service Provider information.
 */

include "mo_saml_visualTour.php";
function miniorange_sp_information($form, &$form_state)
{
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

    global $base_url;

    $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

    $acs_url = $base_url . '/?q=samlassertion';

    $form['markup_top'] = array(
        '#markup' => '<div class="mo_saml_table_layout mo_saml_container"><b><span style="font-size: 17px;">CONFIGURE IDENTITY PROVIDER</span></b><a class="btn btn-primary btn-large restart_button" id="restart_tour_button">'
            . 'Take a Tour</a><br><br><hr>'
    );

    $module_path = drupal_get_path('module', 'miniorange_saml');

    $form['mo_saml_metadata_option'] = array(
        '#markup' => '<br><div style="color: #d9534f;"><b>Provide this module information to your Identity Provider team. You can choose any one of the below options:</b></div>',
    );

    $form['markup_1_idp_sp_1'] = array(
        '#markup' => '<br><div id="mo_saml_vt_metadata"><b>a) Provide this metadata URL to your Identity Provider:</b><br>',
    );

  $form['markup_idp_sp_2'] = array(
    '#markup' => '<div><div class="mo_saml_highlight_background_url_note" "><code id="mo_saml_idp_vt_metadata"><b>'
      . '<span id="idp_metadata_url"><a target="_blank" href="' .  $base_url . '/includes/metadata/?q=mosp_metadata">' .  $base_url . '/includes/metadata/?q=mosp_metadata' . '</a></span></b></code></div>
            <img class ="fa fa-fw fa-lg fa-copy mo_copy" style="margin-left: 10px;" onclick="copyToClipboard(\'#idp_metadata_url\');" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg"><br></div></div>',
  );

  $form['mo_saml_download_btn_title'] = array(
     '#markup' => '<br><br><div id="miniorange_download_metadata"><b>b) Download the Module XML metadata and upload it on your Identity Provider : </b>
                        <span><a href="'.$base_url.'/?q=mosp_download_metadata" class="btn btn-primary btn-large mo_saml_btn" style="padding: 4px 10px;">Download XML Metadata</a></span></div>',
  );

    $form['header'] = array(
        '#markup' => '<br><br><div><b>c) Provide the following information to your Identity Provider. Copy it and keep it handy.</b></div><br>',
    );

    $form['mosaml_vtId']=array(
        '#markup'=>'<div id="mo_saml_vt_id">'
    );

    $form['mo_saml_attrs_list_idp'] = array(
        '#markup' => '<div class="table-responsive" style="font-family: sans-serif;font-size: 12px;" id="mo_idp_vt_conf_table">   
                <table class="mo_guide_table mo_guide_table-striped mo_guide_table-bordered" style="border: 1px solid #ddd;max-width: 100%;border-collapse: collapse;">
                    <thead>
                        <tr>
                            <th class="mo_guide_text-center mo_td_values">ATTRIBUTE</th>
                            <th class="mo_guide_text-center mo_td_values">VALUE</th>   
                            <tbody style="font-size: 12px;color:gray;">
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">IDP-Entity ID / Issuer</td>
                                    <td>						               
						               <span id="issuer_id">' . $base_url . '</span>
                                       <img class ="fa fa-fw fa-pull-right fa-lg fa-copy mo_copy" onclick="copyToClipboard(\'#issuer_id\');" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg">			
						            </td>                                    
                                </tr>
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">ACS URL	</td>
                                    <td>						               
						               <span id="acs_url">' . $acs_url . '</span>
						               <img class ="fa fa-fw fa-pull-right fa-lg fa-copy mo_copy" onclick="copyToClipboard(\'#acs_url\');" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg">       
						            </td>                                    
                                </tr>
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">Audience URI</td>
                                    <td>						               
						               <span id="base_url">' . $base_url . '</span>
						               <img class ="fa fa-fw fa-pull-right fa-lg fa-copy mo_copy" onclick="copyToClipboard(\'#base_url\');" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg">       
						            </td>                                    
                                </tr>
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">Recipient URL</td>
                                    <td>						               
						               <span id="acs_url_1">' . $acs_url . '</span>
						               <img class ="fa fa-fw fa-pull-right fa-lg fa-copy mo_copy" onclick="copyToClipboard(\'#acs_url_1\');" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg">       
						            </td>                                    
                                </tr>
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">Destination URL</td>
                                    <td>						               
						               <span id="dest_url">' . $acs_url . '</span>
						               <img class ="fa fa-fw fa-pull-right fa-lg fa-copy mo_copy" onclick="copyToClipboard(\'#dest_url\');" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg">       
						            </td>                                    
                                </tr>
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">NameID Format</td>
                                    <td>						               
						               <span id="name_id">urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress</span>					                      
						            </td>                                    
                                </tr>
                                
                                                         
                            </tbody>                                                 
                        </tr>
                    </thead>
                    </table>
           <script>               
              function copyToClipboard(element) {
                jQuery(".selected-text").removeClass("selected-text");
                var temp = jQuery("<input>");
                jQuery("body").append(temp);
                jQuery(element).addClass("selected-text");
                temp.val(jQuery(element).text()).select();
                document.execCommand("copy");
                temp.remove();
            }
              jQuery(window).click(function(e) {
                  console.log(e.target.className);
                  if( e.target.className == undefined || e.target.className.indexOf("mo_copy") == -1)
                   jQuery(".selected-text").removeClass("selected-text");
              });
          </script>'
    );

    $form['markup_support_close1'] = array(
        '#markup' => '</div><br></div></div>',
    );

    Utilities::spConfigGuide($form, $form_state);

    Utilities::AddSupportButton($form, $form_state);

    return $form;
}

